condor_advertise(1)

Name

condor_advertiseSend a ClassAd to the condor_collectordaemon

Synopsis
condor_advertise[-help | -version]

condor_advertise[-pool centralmanagerhostname[:portname]] [-debug] [-tcp] [-udp] [-multiple] [update-command [classad-filename]]

Description
condor_advertisesends one or more ClassAds to the condor_collectordaemon on the central manager machine. The optional argument update-commandsays what daemon type's ClassAd is to be updated; if it is absent, it assumed to be the update command corresponding to the type of the (first) ClassAd. The optional argument classad-filenameis the file from which the ClassAd(s) should be read. If classad-filenameis omitted or is the dash character ('-'), then the ClassAd(s) are read from standard input. You must specify update-commandif you do not want to read from standard input.

When -multipleis specified, multiple ClassAds may be published. Publishing many ClassAds in a single invocation of condor_advertiseis more efficient than invoking condor_advertiseonce per ClassAd. The ClassAds are expected to be separated by one or more blank lines. When -multipleis not specified, blank lines are ignored (for backward compatibility). It is best not to rely on blank lines being ignored, as this may change in the future.

The update-commandmay be one of the following strings:

UPDATE_STARTD_AD

UPDATE_SCHEDD_AD

UPDATE_MASTER_AD

UPDATE_GATEWAY_AD

UPDATE_CKPT_SRVR_AD

UPDATE_NEGOTIATOR_AD

UPDATE_HAD_AD

UPDATE_AD_GENERIC

UPDATE_SUBMITTOR_AD

UPDATE_COLLECTOR_AD

UPDATE_LICENSE_AD

UPDATE_STORAGE_AD

condor_advertisecan also be used to invalidate and delete ClassAds currently held by the condor_collectordaemon. In this case the update-commandwill be one of the following strings:

INVALIDATE_STARTD_ADS

INVALIDATE_SCHEDD_ADS

INVALIDATE_MASTER_ADS

INVALIDATE_GATEWAY_ADS

INVALIDATE_CKPT_SRVR_ADS

INVALIDATE_NEGOTIATOR_ADS

INVALIDATE_HAD_ADS

INVALIDATE_ADS_GENERIC

INVALIDATE_SUBMITTOR_ADS

INVALIDATE_COLLECTOR_ADS

INVALIDATE_LICENSE_ADS

INVALIDATE_STORAGE_ADS

For any of these INVALIDATE commands, the ClassAd in the required file consists of three entries. The file contents will be similar to:

MyType = "Query"
TargetType = "Machine"
Requirements = Name == "condor.example.com"

The definition for MyTypeis always Query. TargetTypeis set to the MyTypeof the ad to be deleted. This MyTypeis DaemonMasterfor the condor_masterClassAd, Machinefor the condor_startdClassAd, Schedulerfor the condor_scheddClassAd, and Negotiatorfor the condor_negotiatorClassAd. Requirementsis an expression evaluated within the context of ads of TargetType. When Requirementsevaluates to True, the matching ad is invalidated. A full example is given below.

Options

-help

    Display usage information

-version

    Display version information

-debug

    Print debugging information as the command executes.

-multiple

    Send more than one ClassAd, where the boundary between ClassAds is one or more blank lines.

-pool centralmanagerhostname[:portname]

    Specify a pool by giving the central manager's host name and an optional port number. The default is the COLLECTOR_HOSTspecified in the configuration file.

-tcp

    Use TCP for communication. Used by default if UPDATE_COLLECTOR_WITH_TCPis true.

-udp

    Use UDP for communication.

General Remarks
The job and machine ClassAds are regularly updated. Therefore, the result of condor_advertiseis likely to be overwritten in a very short time. It is unlikely that either HTCondor users (those who submit jobs) or administrators will ever have a use for this command. If it is desired to update or set a ClassAd attribute, the condor_config_valcommand is the proper command to use.

Attributes are defined in Appendix A of the HTCondor manual.

For those administrators who do need condor_advertise, the following attributes may be included:

DaemonStartTime

UpdateSequenceNumber

If both of the above are included, the condor_collectorwill automatically include the following attributes:

UpdatesTotal

UpdatesLost

UpdatesSequenced

UpdatesHistory

    Affected by COLLECTOR_DAEMON_HISTORY_SIZE.

Examples

Assume that a machine called condor.example.com is turned off, yet its condor_startdClassAd does not expire for another 20 minutes. To avoid this machine being matched, an administrator chooses to delete the machine's condor_startdClassAd. Create a file (called remove_filein this example) with the three required attributes:

MyType = "Query"
TargetType = "Machine"
Requirements = Name == "condor.example.com"

This file is used with the command:

% condor_advertise INVALIDATE_STARTD_ADS remove_file

Exit Status

condor_advertisewill exit with a status value of 0 (zero) upon success, and it will exit with the value 1 (one) upon failure. Success means that all ClassAds were successfully sent to all condor_collectordaemons. When there are multiple ClassAds or multiple condor_collectordaemons, it is possible that some but not all publications succeed; in this case, the exit status is 1, indicating failure.

Author
Center for High Throughput Computing, University of Wisconsin&ndash;Madison

Copyright
Copyright © 1990-2019 Center for High Throughput Computing, Computer Sciences Department, University of Wisconsin-Madison, Madison, WI. All Rights Reserved. Licensed under the Apache License, Version 2.0.